<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_InternalSupplier2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_InternalSupplier2 extends AbstractStructArrayBase
{
    /**
     * The InternalFlightSupplier
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_InternalSupplier[]
     */
    public $InternalFlightSupplier;
    /**
     * Constructor method for ArrayOfJP_InternalSupplier2
     * @uses ArrayOfJP_InternalSupplier2::setInternalFlightSupplier()
     * @param \StructType\JP_InternalSupplier[] $internalFlightSupplier
     */
    public function __construct(array $internalFlightSupplier = array())
    {
        $this
            ->setInternalFlightSupplier($internalFlightSupplier);
    }
    /**
     * Get InternalFlightSupplier value
     * @return \StructType\JP_InternalSupplier[]|null
     */
    public function getInternalFlightSupplier()
    {
        return $this->InternalFlightSupplier;
    }
    /**
     * This method is responsible for validating the values passed to the setInternalFlightSupplier method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInternalFlightSupplier method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInternalFlightSupplierForArrayConstraintsFromSetInternalFlightSupplier(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_InternalSupplier2InternalFlightSupplierItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_InternalSupplier2InternalFlightSupplierItem instanceof \StructType\JP_InternalSupplier) {
                $invalidValues[] = is_object($arrayOfJP_InternalSupplier2InternalFlightSupplierItem) ? get_class($arrayOfJP_InternalSupplier2InternalFlightSupplierItem) : sprintf('%s(%s)', gettype($arrayOfJP_InternalSupplier2InternalFlightSupplierItem), var_export($arrayOfJP_InternalSupplier2InternalFlightSupplierItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InternalFlightSupplier property can only contain items of type \StructType\JP_InternalSupplier, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InternalFlightSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_InternalSupplier[] $internalFlightSupplier
     * @return \ArrayType\ArrayOfJP_InternalSupplier2
     */
    public function setInternalFlightSupplier(array $internalFlightSupplier = array())
    {
        // validation for constraint: array
        if ('' !== ($internalFlightSupplierArrayErrorMessage = self::validateInternalFlightSupplierForArrayConstraintsFromSetInternalFlightSupplier($internalFlightSupplier))) {
            throw new \InvalidArgumentException($internalFlightSupplierArrayErrorMessage, __LINE__);
        }
        $this->InternalFlightSupplier = $internalFlightSupplier;
        return $this;
    }
    /**
     * Add item to InternalFlightSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_InternalSupplier $item
     * @return \ArrayType\ArrayOfJP_InternalSupplier2
     */
    public function addToInternalFlightSupplier(\StructType\JP_InternalSupplier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_InternalSupplier) {
            throw new \InvalidArgumentException(sprintf('The InternalFlightSupplier property can only contain items of type \StructType\JP_InternalSupplier, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InternalFlightSupplier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_InternalSupplier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_InternalSupplier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InternalFlightSupplier
     */
    public function getAttributeName()
    {
        return 'InternalFlightSupplier';
    }
}
